streamopen(name param dir)
{
	defstream $(name) $param basic $dir;
	global $(name)_dir    = $dir
		   $(name)_cooked = true;
}

streamclose(name)
{
	remove GLOBALS $(name)_dir
	remove GLOBALS $(name)_cooked
	rmstream $name
}

ioctl(name ctlstr)
{
	switch $ctlstr
		when eq($^ cooked)
			set $(name)_cooked = true
			breaksw
		when eq($^ raw)
			set $(name)_cooked = ''
			breaksw
		when eq($^ ?cooked)
			return(cond($(name)_cooked cooked raw))
			breaksw
		when eq($^ flush)
			return(ioctl($name flush))
			breaksw
		when match($^ flowctl=*)
			return(ioctl($name $ctlstr))
			breaksw
		case *
			return(not-implemented)
	endsw
}


rewind(name)
{
	rewind $name
}

getpos(name)
{
	return(getpos($name))
}

setpos(name pos)
{
	setpos $name $pos
}
