.module <files>
.pool diversions
main
{
	table identity +get(ARGV 1)
	global allow_tags = list(A /A B /B BR EM /EM I /I IMG 
							P /P STRONG /STRONG UL OL /UL /OL LI /LI &)
			nextfile emptyline = true newsmode;
	shared titleline headline body;
	defstream header 'inline://diversions/headline' html true;
	defstream title 'inline://diversions/titleline' html true;
	defstream body 'inline://diversions/body' html true;
	set newsmode = cond(check(identity newsmode) eq(get(identity newsmode) separate))
	if not($newsmode)
		defstream destination "file://get(identity news).html" basic true;
	endif
	defstream hotdest "file://get(identity hotnews).html" basic true;
	def i nf = get(identity news) ne = get(identity newsext) nm = get(identity newsmax);
	global nprev = cond(check(identity newsprev) get(identity newsprev))
		nnext = cond(check(identity newsnext) get(identity newsnext))
		nfirst = cond(check(identity newsnext) get(identity newsfirst))
		nlast = cond(check(identity newsnext) get(identity newslast));
	foreach i iota($nm)
		decr i 1
		if exists($nf\.$i$ne)
			defstream source "file://$nf\.$i$ne" html;
			if $newsmode
				defstream destination "file://$nf\.$i\.html" basic true;
			endif
			set nextfile = ''
			set titleline = ''
			set body = ''
			set headline = ''
			while;
				readfrom(source)
				if iseof() break endif
				dispatch
				if $nextfile break endif
			loop
			set titleline = make-substit(get(identity newstitle) $i $nm $titleline)
			set headline = make-substit(get(identity newsheader) $i $nm $titleline$headline)
			set body = make-substit(get(identity newsbody) $i $nm $titleline$body)
			writeto hotdest $headline
			writeto destination $body
			rmstream source
			if $newsmode
				rmstream destination
			endif
		endif
	loop
}

make-substit(pattern i maxi value)
{
	set pattern = substit($pattern %% $i)
	set pattern = substit($pattern %- cond(eq(int $i 0) $nfirst substit($nprev %% sub($i 1))))
	set pattern = substit($pattern %+ cond(eq(int $i $maxi) $nlast substit($nnext %% add($i 1))))
	set pattern = substit($pattern % $value first);
	return($pattern)
}

tag "HEAD"
{
	outstream header
}

tag "/HEAD"
{
	outstream body
}

tag "TITLE"
{
	outstream title
}

tag "/TITLE"
{
	outstream header
}

tag "BODY"
{
	outstream body
}

tag "/BODY"
{
	set nextfile = true	
}

tag "/ARTICLE"
{
	set nextfile = true
}

tag "*"
{
	if check($allow_tags $[])
		writetag;
	endif
}

char "\n"
{
	if $emptyline writetag P; 
	endif
	writetag;
}

char "[[:space:]]"
{
	writetag;
}

char "?"
{
	set emptyline = ''
	writetag;
}
