.module <crypt>
.module <files>

.do { defautoseq _session_tohex unicode:Tohex16 }
init-session(name)
{
	def ssid = translate(_session_tohex substr(crypt(pid()id()$name '$1$nsl') 6));
	table "_session_$ssid" "!/tmp/.nsl-session-$ssid\.t";
	return($ssid);
}

session-var(id name pool='' ...)
{
	if not($pool)
		if check(GLOBALS $name)
			insert "_session_$id" "global $name" get(GLOBALS $name);
		else
			error "No such variable: $name"
		endif
		if arg(4)
			call(arg(4) $id get(GLOBALS $name) passargs(5))
		endif
	else
		using $pool
		if check(SHAREDS $name)
			insert "_session_$id" "shared using() $name" get(SHAREDS $name);
		else
			error "No such variable: $name in $pool"
		endif
		if arg(4)
			call(arg(4) $id get(GLOBALS $name) passargs(5))
		endif
	endif
}

session-storage(id name type ...)
{
	insert "_session_$id" "storage $name" $type;
	def iter;
	foreach iter $name
		insert "_session_$id" "within $name\t$iter" get($name $iter)
		if arg(4)
			call(arg(4) $id get($name $iter) passargs(5))
		endif
	loop
}

session-close(id)
{
	release storage "_session_$id"
}

delete-session(id)
{
	rmfile "/tmp/.nsl-session-$id\.t"
}
