.module <postgres>
main
{
	def dbname = trim(readline('Database:'));
	def outfile = trim(readline('Output file:'));
	def que = trim(readline('Query:'));
	defstream outstream $outfile html writeable;
	outstream outstream;
	safe-sql(connect "dbname=\'$dbname\'");
	def result = safe-sql(query $que);
	def row;
	writetag html;
	writetag body;
	if eq(int(count($result)) int(0))
		write 'Sorry, no tuples for you query\n';
	else
		set row = get($result 0);
		def fld;
		def rno;
		writetag table border 1;
		foreach fld $row
			writetag th;
			write $fld;
			writetag /th;
		loop
		write '\n';
		foreach rno $result
		{
			set row = local(get($result $rno));
			writetag tr;
			foreach fld $row
				writetag td;
				write get($row $fld);
				writetag /td;
			loop
			writetag /tr;
			write '\n';
		}
		loop
		writetag /table;
	endif 
	writetag /body;
	writetag /html;
	release storage $result;
	safe-sql(disconnect);
	exit
}

safe-sql
{
	def r = sql($1 $2);
	if(sql(error))
		echo sql(error);
		exit
	endif
	if(sql(response))
		echo sql(response)
	endif
	sql(clearerr);
	return($r);
}
