realmain(file logging='')
{
	global :restart :next :current :state :filename :capture :supress :translator __logging;
	read
	write 'Content-Type: text/html'
	write ''
	load($file)
	init()
	def tmp tmp1 all = $[*];
	while $all
		set all = split($all '\t' '\n' tmp tmp1)
		global query.$tmp = $tmp1
	loop;
	set :filename = getenv(PATH_TRANSLATED)
	defstream input $:filename html;
	if $logging
		defstream logfile $logging basic true
		set __logging = true
	endif
	ioctl(input keepspaces)
	instream input
	if isproc(user-atbof) user-atbof() endif
	while;
		set :current = getpos(input)
		read
		set :next = getpos(input)
		if iseof() break endif
		if not($[])
			if $:capture
				set $:capture = var($:capture)$[value]
			elsif not($:supress)
				write translate($:translator $[value])
			endif
		else
			if do-handler() break endif
		endif
	loop;
	if and(iseof() isproc(user-ateof)) user-ateof() endif
}

message(text)
{
	if $__logging
		writeto logfile $text\n
	else
		echo $text
	endif
}

do-handler()
{
	def tmp newstate oldstate;
	while;
		if $newstate
			set oldstate = $:state
			set :state   = $newstate
		endif
		set tmp = handler($:restart)
		if $newstate
			set :state = $oldstate
		endif
		if eq($tmp nextfile) return(true) endif
		if isprefix($tmp restart)
			split($tmp ' ' '' '' :restart newstate)
		else
			break
		endif
	loop
}
