.do { defautoseq read-utf8 utf8:Read 
	  defautoseq convert-utf8 utf8:Tounicode
}

streamopen(name arg writable)
{
	if eq(substr($arg 0 1) '?')
		import stream "utf8_$name" substr($arg 1); 
	else
		defstream "utf8_$name" $arg html;
	endif
	global utf8_error_$name = std_error;
}

std_error(name arg)
{
	error "Bad UTF8 seq	near getpos(utf8_$name)\n"
}

read(name)
{
	reset(read-utf8)
	reset(convert-utf8)
	def a = readfrom("utf8_$name" read-utf8);
	if not(iseof())
		if and($a greater(int length($a) 1))
			settag '' &
			settag value dec(trim(itranslate(convert-utf8 $a)))
		endif
		if not(isfinal(convert-utf8))
			call var(utf8_error_$name) $name $a;
		endif
	endif
}

streamclose(name)
{
	release stream "utf8_$name"
}

ioctl(name ctl)
{
	def fld rest;
	set rest = split($ctl '=' '' fld)
	if eq($fld badutf)
		if eq($rest ?)
			return(var(utf8_error_$name))
		else
			def old = var(utf8_error_$name);
			set utf8_error_$name = cond($rest $rest std_error)
			return($old)
		endif
	elsif eq($fld pass)
		return(ioctl(utf8_$name $rest)) 
	else
		return("not-implemented");
	endif
}

getpos(name)
{
	return(getpos(utf8_$name))
}

setpos(name pos)
{
	setpos utf8_$name $pos
}

rewind(name)
{
	rewind utf8_$name
}
