.module <readline>
.module <postgres>
main
{
	if not(sql(feature connect))
		error "SQL implementation is not full-functional"
	endif
	global dbname = trim(readline('Database:'));
	if not($dbname) exit endif
	sql connect "dbname = $dbname";
	if not(check-sql-error()) exit endif
	def quebuf;
	def que;
	def a;
	def b;
	def row;
	while set(quebuf get-query())
		set que = sql(query $quebuf)
		if check-sql-error()
			if neq(count($que) 0)
				set row = get($que 0)
				foreach a $row
					write "$a\t";
				loop
				write '\n';
				release storage $row
				foreach a $que
					set row = get($que $a);
					foreach b $row
						write "get($row $b)\t";
					loop
					write '\n';
					release storage $row
				loop
			endif
		endif
		release storage $que;
	loop
	sql disconnect;
}

check-sql-error
{
	if sql(error)
		echo "ERROR: sql(error)"
		sql clearerr;
		return('');
	else
		if sql(response)
			echo "RESPONSE: sql(response)"
			sql clearerr;
		endif
		return(true);
	endif
}

get-query
{
	def que;
	def tmp;
	def pref = '>';
	while;
		set tmp = readline($dbname$pref)
		if not($tmp) 
			if not($que) return; endif
			set pref = '>';
			set que = '';
			continue;
		endif
		set que = "$que\n$tmp"
		if eq(substr(trim($que) sub(length(trim($que)) 1) 1) ';')
			return($que);
		endif
		set pref = '>>'
	loop
}
